Attribute VB_Name = "Bits"
Private Const Bit0 = 1
Private Const Bit1 = 2
Private Const Bit2 = 4
Private Const Bit3 = 8
Private Const Bit4 = 16
Private Const Bit5 = 32
Private Const Bit6 = 64
Private Const Bit7 = 128


'SetBit : Set or clear a particular bit in a byte.

'Params :-
'Bits   : Byte to change.
'Bit    : Bit to set
'Value  : Value ( 0 or 1 )

Public Sub SetBit(Bits As Byte, Bit As Byte, Value As Byte)

    If Value = 0 Then
    
        'Clear the bit
        Bits = Bits And (255 Xor (2 ^ Bit))

    Else
        
        ' Set the bit
        Bits = Bits Or 2 ^ Bit

    End If
    
End Sub


'NotBit : Negate a particular bit in a byte.

'Params :-
'Bits   : Byte to change
'Bit    : Bit to negate

Sub NotBit(Bits As Byte, Bit As Byte)

    Bits = Bits Xor (2 ^ Bit)

End Sub


'ChkBit : Return the value ( 0 or 1 ) of a particular bit in a byte.

'Params :-
'Bits   : Byte to check
'Bit    : Bit to examine.

Public Function ChkBit(ByVal Bits As Byte, Bit As Byte) As Byte

    
    ChkBit = (Bits And (2 ^ Bit)) / (2 ^ Bit)
    
End Function


'BitsToString : Return a string represention of the bit values in a byte.

'Params :-
'Byte  : Byte to convert

Public Function BitsToString(ByVal Bits As Byte) As String


Dim Bit As Integer
Dim Result As String

    Result = ""
    For n = 0 To 7
    
        Bit = 2 ^ n
        
        If (Bits And Bit) = 0 Then
            Result = "0" & Result
        Else
            Result = "1" & Result
        End If
            
    Next
    
    BitsToString = Result

End Function


'StringToBits : Convert a string represention of the bit values in a byte to a byte value.

'Params :-
'Bits   : String representing bit values in a byte.

Function StringToBits(Bits As String) As Byte

Dim Result As Byte
Dim n As Integer

    
    Result = 0
    If Len(Bits) = 8 Then
    
        For n = 1 To 7
        
            Result = Result + Val(Mid(Bits, n, 1))
            Result = Result * 2
    
        Next
        
        Result = Result + Val(Mid(Bits, 8, 1))
    Else
        
        MsgBox "N.o. of bits must = 8!", vbExclamation

    End If
    
    StringToBits = Result
    
End Function

